---
title: <maction>
slug: Web/MathML/Element/maction
tags:
  - MathML
  - MathML Reference
  - 'MathML:Element'
  - 'MathML:Enlivening Expressions'
---
<div>{{MathMLRef}}</div>

<div class="summary">
<p>The MathML <strong><code>&lt;maction&gt;</code></strong> element provides a possibility to bind actions to (sub-) expressions. The action itself is specified by the <code>actiontype</code> attribute, which accepts several values. To specify which child elements are addressed by the action, you can make use of the <code>selection</code> attribute.</p>
</div>

<h2 id="Attributes">Attributes</h2>

<dl>
	<dt id="attr-actiontype">actiontype</dt>
	<dd>The action which specifies what happens for this element. Possible values are:
	<ul>
		<li><code>statusline</code>: If there is a click on the <em>expression</em> or the reader moves the pointer over it, the <em>message</em> is sent to the browser's status line. The syntax is: <code>&lt;maction actiontype="statusline"&gt; <em>expression</em> <em>message</em> &lt;/maction&gt;.</code></li>
		<li><code>toggle</code>: When there is a click on the subexpression, the rendering alternates the display of selected subexpressions. Therefore each click increments the <code>selection</code> value.<br>
		The syntax is: <code>&lt;maction actiontype="toggle" selection="<em>positive-integer</em>" &gt; <em>expression1</em> <em>expression2</em> <em>expressionN</em> &lt;/maction&gt;</code>.</li>
		<li><code>tooltip</code>: When the pointer moves over the <em>expression</em>, a tooltip box with a <em>message</em> is displayed near the expression.<br>
		The syntax is:<code> &lt;maction actiontype="tooltip"&gt; <em>expression</em> <em>message</em> &lt;/maction&gt;.</code></li>
	</ul>
	</dd>
	<dt id="attr-class-id-style">class, id, style</dt>
	<dd>Provided for use with <a href="/en-US/docs/CSS">stylesheets</a>.</dd>
	<dt id="attr-displaystyle"><code>displaystyle</code></dt>
	<dd>A Boolean value specifying whether more vertical space is used for displayed equations or, if set to <code>false</code>, a more compact layout is used to display formulas. The main effect is that larger versions of operators are displayed, when <code>displaystyle</code> is set to <code>true</code>. See also <code>largeop</code> and <code>movablelimits</code> on {{ MathMLElement("mo") }}.</dd>
	<dt id="attr-href">href</dt>
	<dd>Used to set a hyperlink to a specified URI.</dd>
	<dt id="attr-mathbackground">mathbackground</dt>
	<dd>The background color. You can use <code>#rgb</code>, <code>#rrggbb</code> and <a href="/en-US/docs/CSS/color_value#Color_Keywords">HTML color names</a>.</dd>
	<dt id="attr-mathcolor">mathcolor</dt>
	<dd>The text color and also the fraction line color. You can use <code>#rgb</code>, <code>#rrggbb</code> and <a href="/en-US/docs/CSS/color_value#Color_Keywords">HTML color names</a>.</dd>
	<dt id="attr-selection">selection</dt>
	<dd>The child element which is addressed by the action. The default value is <code>1</code>, which is the first child element.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following example uses the "toggle" <code>actiontype</code>:</p>

<pre class="brush: html notranslate">&lt;math&gt;

&lt;maction actiontype="toggle"&gt;

  &lt;mfrac&gt;
    &lt;mn&gt;6&lt;/mn&gt;
    &lt;mn&gt;8&lt;/mn&gt;
  &lt;/mfrac&gt;

  &lt;mfrac&gt;
    &lt;mrow&gt;
      &lt;mn&gt;3&lt;/mn&gt;
      &lt;mo&gt;&amp;sdot;&lt;/mo&gt;
      &lt;mn&gt;2&lt;/mn&gt;
    &lt;/mrow&gt;
    &lt;mrow&gt;
      &lt;mn&gt;4&lt;/mn&gt;
      &lt;mo&gt;&amp;sdot;&lt;/mo&gt;
      &lt;mn&gt;2&lt;/mn&gt;
    &lt;/mrow&gt;
  &lt;/mfrac&gt;

  &lt;mfrac&gt;
    &lt;mn&gt;3&lt;/mn&gt;
    &lt;mn&gt;4&lt;/mn&gt;
  &lt;/mfrac&gt;

&lt;/maction&gt;

&lt;/math&gt;
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName("MathMLCore", "#dfn-maction", "maction")}}</td>
			<td>{{Spec2("MathMLCore")}}</td>
			<td>Draft specification</td>
		</tr>
		<tr>
			<td>{{ SpecName('MathML3', 'chapter3.html#presm.maction', 'maction') }}</td>
			<td>{{ Spec2('MathML3') }}</td>
			<td>Current specification</td>
		</tr>
		<tr>
			<td>{{ SpecName('MathML2', 'chapter3.html#presm.maction', 'maction') }}</td>
			<td>{{ Spec2('MathML2') }}</td>
			<td>Initial specification</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("mathml.elements.maction")}}</p>

<h2 id="Gecko-specific_notes">Gecko-specific notes</h2>

<ul>
	<li>Prior to Gecko 9.0 {{ geckoRelease("9.0") }} the non-standard <code>restyle</code> value on the <code>actiontype</code> attribute was supported. This value has been removed.</li>
	<li>Prior to Gecko 14.0 {{ geckoRelease("14.0") }} the <code>statusline</code> action type was using a non-standard syntax (see below). This has been fixed to follow the MathML specification.
	<pre class="brush: html notranslate">&lt;maction actiontype="statusline#(message)"&gt;
(expression)
&lt;/maction&gt;
</pre>
	</li>
	<li>With Gecko 15.0 {{geckoRelease("15.0")}} the <code>selection</code> attribute is only taken into account with the actiontype <code>"toggle"</code>.</li>
	<li>Starting with Gecko 16.0 {{geckoRelease("16.0")}} the <code>selection</code> attribute is also taken into account when an unknown <code>actiontype</code> is specified. If an <code>actiontype</code> is not specified (is empty) or when the <code>selection</code> attribute is invalid, the markup will throw an MathML error (invalid-markup).</li>
</ul>
